import { Hand } from "cerke_hands_and_score";
import { AbsoluteCoord, Color, Profession, Season, TamMove } from "cerke_online_api";
import { Munch } from "./munch_monad";
export interface NormalNonTamMoveExceptFromHopzuo {
    type: "NonTamMove";
    data: {
        type: "SrcDst";
        src: AbsoluteCoord;
        dest: AbsoluteCoord;
    } | {
        type: "SrcStepDst";
        src: AbsoluteCoord;
        step: AbsoluteCoord;
        dest: AbsoluteCoord;
    };
}
declare type CiurlAndCapture = {
    ciurl_event: CiurlEvent;
    piece_capture?: {
        color: Color;
        prof: Profession;
    };
};
export declare type BodyElement = {
    "type": "normal_move";
    movement: NormalNonTamMoveExceptFromHopzuo;
    ciurl_and_capture: CiurlAndCapture;
} | {
    "type": "from_hopzuo";
    movement: {
        type: "NonTamMove";
        data: {
            type: "FromHop1Zuo1";
            color: Color;
            prof: Profession;
            dest: AbsoluteCoord;
        };
    };
} | {
    "type": "tam_move";
    movement: TamMove;
} | {
    "type": "end_season";
} | {
    "type": "go_again";
} | {
    "type": "game_set";
} | {
    "type": "season_ends";
    season: Season;
} | {
    "type": "before_tymok";
    hands: Hand[];
} | {
    "type": "before_taxot";
    hands: Hand[];
    score: number;
};
export declare function handleTamMove(s: string): BodyElement;
export declare function handleYaku(s: string): BodyElement;
export declare type CiurlEvent = {
    type: "no_ciurl_event";
} | {
    type: "only_stepping";
    stepping_ciurl: number;
    infafterstep_success: boolean;
} | {
    type: "has_water_entry";
    stepping_ciurl?: number;
    water_entry_ciurl: number;
};
export declare const munchWaterEvent: Munch<number>;
export declare const munchCiurlEvent: Munch<CiurlEvent>;
export declare function handleTrailingParameters(s: string): {
    ciurl_event: CiurlEvent;
    piece_capture?: {
        color: Color;
        prof: Profession;
    };
};
export declare function handleBodyElement(s: string): BodyElement;
export {};
