"use strict";
/*-----------------------------------------------------
 * Copied & pasted from https://github.com/jurliyuuri/cerke_online_alpha/blob/b01330b08b791cb97b67d47d5b7479c7b51dcf7b/src/to_digits.ts
 * I should make this an npm package and export it, rather than copying & pasitng the code ...
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.toDigitsLinzklar = void 0;
function toDigitsLinzklar(num) {
    function toLinzklar(a) {
        const obj = {
            neg: "下",
            num00: "無",
            num01: "一",
            num02: "二",
            num03: "三",
            num04: "四",
            num05: "五",
            num06: "六",
            num07: "七",
            num08: "八",
            num09: "九",
            num10: "十",
            num100: "百",
        };
        return obj[a];
    }
    return toDigits(num).map(toLinzklar);
}
exports.toDigitsLinzklar = toDigitsLinzklar;
function toDigits(num) {
    if (num % 1 !== 0) {
        throw new Error("non-integer");
    }
    else if (num >= 200) {
        const lastHundredArr = num % 100 === 0 ? [] : toDigitsSub(num % 100);
        return [...toDigitsSub(Math.floor(num / 100)), "num100", ...lastHundredArr];
    }
    else if (num >= 100) {
        const lastHundredArr = num % 100 === 0 ? [] : toDigits(num % 100);
        return ["num100", ...lastHundredArr];
    }
    else if (num < 0) {
        return ["neg", ...toDigits(-num)];
    }
    else if (num == 0) {
        return ["num00"];
    }
    const lastDigitArr = num % 10 === 0 ? [] : [`num0${num % 10}`];
    if (num >= 20) {
        return [`num0${Math.floor(num / 10)}`, "num10", ...lastDigitArr];
    }
    else if (num >= 10) {
        return ["num10", ...lastDigitArr];
    }
    else {
        return lastDigitArr;
    }
}
// -6848 should be 下六八百四八, not 下六十八百四十八. This function thus converts 68 to 六八, not 六十八.
function toDigitsSub(num) {
    if (num % 1 !== 0) {
        throw new Error("non-integer");
    }
    else if (num >= 100) {
        throw new Error("100 or more detected in toDigitsSub");
    }
    else if (num <= 0) {
        throw new Error("0 or less detected in toDigitsSub");
    }
    if (num % 10 === 0) {
        if (num >= 20) {
            return [`num0${Math.floor(num / 10)}`, "num10"];
        }
        else if (num == 10) {
            return ["num10"];
        }
        else {
            throw new Error("cannot happen");
        }
    }
    else {
        const lastDigit = `num0${num % 10}`;
        if (num >= 20) {
            return [`num0${Math.floor(num / 10)}`, lastDigit];
        }
        else if (num >= 10) {
            return ["num10", lastDigit];
        }
        else {
            return [lastDigit];
        }
    }
}
/*-----------------------------------------------------*/
const read_pekzep_numerals_1 = require("./read_pekzep_numerals");
test('numerals', () => {
    for (let i = -9999; i <= 9999; i++) {
        expect((0, read_pekzep_numerals_1.fromDigitsLinzklar)(toDigitsLinzklar(i))).toBe(i);
    }
});
test("incorrect numerals", () => {
    expect(() => (0, read_pekzep_numerals_1.fromDigitsLinzklar)(["無", "無"])).toThrow();
    expect(() => (0, read_pekzep_numerals_1.fromDigitsLinzklar)(["三", "無"])).toThrow();
    expect(() => (0, read_pekzep_numerals_1.fromDigitsLinzklar)(["十", "下"])).toThrow();
});
